/*
 * Tab button
 *
 * Index
 * - Button
 * - Native
 * - Underline
 * - Inner
 * - Icon
 * - Label
 *
 */

/**
 * @prop --padding-start: Left padding  of the button
 * @prop --padding-end: Right padding of the button
 * @prop --tab-color: Default color of the tab button text
 * @prop --tab-color-selected: Color of the tab button text when selected
 * @prop --tab-unerline-selected: Color of the tab button underline when selected
 * @prop --tab-background-hover: Color of the tab button when hover by a mouse
 * @prop --tab-background-focused: Color of the tab button when focused with the tab key
 */


/* BUTTON
 -------------------- */

:host {
  box-sizing: border-box;
  font-weight: 700;
  color: var(--tab-color);
  outline: 0;
  transition: background 0.15s ease-in-out;
}

/**
 * Active state
 */

:host(.tab-secondary) {
  --tab-underline-selected: var(--road-secondary-600);
}

:host(.tab-selected) {
  color: var(--tab-color-selected);
}

:host(.tab-selected) ::slotted(road-icon) {
  color: var(--tab-color-selected);
}

:host(.tab-selected) .button-native::after {
  height: 2px;
  background: var(--tab-underline-selected);
  opacity: 1;
  transform: none;
}

/**
 * Hover state
 */

:host(:hover) {
  background: var(--tab-background-hover);
}

/**
 * Focus state
 */

:host(.focus-visible) {
  background: var(--tab-background-focused);
  outline: auto;
}

/**
 * Disabled
 */

:host(.tab-disabled) {
  background: var(--road-surface-disabled);
}

:host(.tab-disabled) .button-native{
  cursor: not-allowed;
}

:host(.tab-disabled) ::slotted(road-label) {
  color: var(--road-on-surface-disabled);
}


/* NATIVE
 -------------------- */

.button-native {
  position: relative;
  box-sizing: border-box;
  display: flex;
  flex-direction: inherit;
  align-items: inherit;
  justify-content: inherit;
  width: 100%;
  height: 100%;
  min-height: 3.5rem;
  padding: 0.75rem var(--padding-end, 1.5rem) 0.75rem var(--padding-start, 1.5rem);
  margin: 0;
  overflow: hidden;
  font-family: inherit;
  font-size: inherit;
  font-style: inherit;
  font-weight: inherit;
  color: inherit;
  text-align: inherit;
  text-decoration: none;
  text-indent: inherit;
  text-overflow: inherit;
  text-transform: inherit;
  letter-spacing: inherit;
  white-space: inherit;
  cursor: pointer;
  background: transparent;
  -webkit-user-drag: none;
  border-color: initial;
  border-style: initial;
  border-width: 0;
  border-radius: inherit;
  border-image: initial;
  outline: none;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

/* UNDERLINE
 -------------------- */

.button-native::after {
  position: absolute;
  bottom: 0;
  left: 0;
  display: block;
  width: 100%;
  height: 0;
  content: "";
  background-color: var(--road-input-outline);
  opacity: 1;
  transition: transform 0.25s cubic-bezier(0.4, 0, 0.2, 1);
  transform: none;
  transform-origin: center;
}

/* INNER
 -------------------- */

.button-inner {
  position: relative;
  z-index: 1;
  display: flex;
  flex-flow: inherit;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
}

/* ICON
 -------------------- */

:host ::slotted(road-icon) {
  color: var(--tab-color);
}

:host(.tab-layout-icon-start) ::slotted(road-icon) {
  margin-right: 0.5rem;
}

:host(.tab-layout-icon-top) .button-inner {
  flex-direction: column;
}

/* LABEL
 -------------------- */

:host ::slotted(road-label) {
  display: -webkit-box;
  max-width: 12.5rem;
  overflow: hidden;
  font-size: 1rem;
  color: var(--road-on-surface);
  -webkit-line-clamp: 1;
  -webkit-box-orient: vertical;
  text-align: center;
  text-overflow: ellipsis;
  white-space: inherit;
}

:host(.tab-layout-icon-top) ::slotted(road-label) {
  margin-top: 0.25rem;
  font-size: 1rem;
}
